abstract class IntSet() {
  def add(x: Int): IntSet
  def contains(x: Int): Boolean
}

class NonEmpty(elem: Int, left: IntSet, right: IntSet) extends IntSet() {
  def add(x: Int): IntSet = {
    if (x < elem) new NonEmpty(elem, left add x, right)
    else if (x > elem) new NonEmpty(elem, left, right add x)
    else this
  }

  def contains(x: Int): Boolean =
    if (x < elem) left contains x
    else if (x > elem) right contains x
    else true

  override def toString = "(" + left + "|" + elem + "|" + right + ")"
}

object Empty extends IntSet() {
  def add(x: Int): IntSet = new NonEmpty(x, Empty, Empty)
  def contains(x: Int): Boolean = false
  override def toString = "-"
}

val t1 = Empty
val t2 = t1 add 3
val t3 = t1 add 4 add 5 add 2 add 6
t3 contains 4

println(Empty)                  // prints -
println(Empty.add(3))           // prints (-|3|-)
println(Empty.add(3).add(2))    // prints ((-|2|-)|3|-)